> ## Documentation Index
> Fetch the complete documentation index at: https://help.commbox.io/llms.txt
> Use this file to discover all available pages before exploring further.

# External CSAT

> This API enables Organizations to import external customer satisfaction surveys (CSAT) into the CommBox platform, attaching them to existing conversations and tagging the conversation appropriately.<br><br>You'll need to open a designated channel in the Customer Satisfaction Survey Module. The channel ID will be the value for the `surveyStreamId` parameter in the API request. Click [here](https://help.commbox.io/docs/external-csat-api) to learn more.<br><br>**Note:**<br> - The example below is for a single-question survey. Multiple-question arrays are also supported.<br> - The first answer always represents the highest satisfaction score (**100%**), while the last answer represents the lowest satisfaction score (**0%**). Scores for intermediate answers are distributed evenly between these values.

## OpenAPI

````json POST /objects/{objectId}/survey
{
  "openapi": "3.0.3",
  "info": {
    "title": "CommBox API",
    "x-logo": {
      "url": "https://www.commbox.io/logo/commbox_logo_large.png"
    },
    "version": "2.07",
    "termsOfService": "https://www.commbox.io/end-user-license-agreement-eula/",
    "contact": {
      "name": "commbox",
      "url": "https://www.commbox.io",
      "email": "contactus@commbox.io"
    }
  },
  "servers": [
    {
      "url": "https://api.commbox.io/",
      "description": "Production server"
    }
  ],
  "security": [
    {
      "BearerAuth": []
    }
  ],
  "tags": [
    {
      "name": "Core",
      "description": "<br><br>Systemwide verification"
    },
    {
      "name": "Objects",
      "description": "<br><br>Objects are conversations between the AI Agent or the human agent and the customers, where each segment of the conversation is referred to as a Child. Every conversation must have a designated Stream – a communication channel such as Chat, Email, Text/SMS, etc., through which the conversation takes place.<br>The <b>Object APIs</b> category concentrates on a specific conversation, where the Stream is part of the identifying parameters. In contrast, the <b>Streams APIs</b> category, the Channel is the focal point of the request, and the objects and users are the filtering aspects."
    },
    {
      "name": "Media",
      "description": "Converting media files to Base64"
    },
    {
      "name": "AI Services",
      "description": "APIs that provide AI capabilities by the platform. "
    },
    {
      "name": "Streams",
      "description": "<br><br>Streams are communication channels used in CommBox, such as Chat, WhatsApp, SMS/Text, etc. In the Streams category of APIs, the channel is the focal point of the request, and the objects and users are the filtering aspects. See the Enums Section for available channels and their CommBox code."
    },
    {
      "name": "Tags",
      "description": "<br><br>Tags are a classification tool for summarizing aspects of the conversation or the user. It can mark the conversation to indicate a new sale or identify a customer as not interested in the product. To help manage the Tags assets, Tags can be grouped with a common identifier."
    },
    {
      "name": "SMS",
      "description": "<br><br>Sending customers **SMS messages** (Texting) requires an initial opt-in step, which is not offered by CommBox and is the sole responsibility of the sending entity (Business)."
    },
    {
      "name": "WhatsApp",
      "description": "<br><br>CommBox facilitates activities in **WABA** for the clients. Our platform helps clients create new templates and manage existing ones.<br><br> **Opt-in for WhatsApp**<br> Before sending WhatsApp messages to someone, you must first receive opt-in permission confirming that they wish to receive future messages from you on WhatsApp. This can be done using any channel your business uses to communicate with people — your website, app, email, retail location, etc.</br><ul><li>The opt-in must be an active opt-in, which means it must be triggered by a user action, such as entering a phone number or checking a box to indicate consent.</br><li>The opt-in must clearly state your business’ name.</br><li>Clear opt-in messaging so that the customers know what type(s) of messaging they are signing up for.<br>For more information, please visit: https://developers.facebook.com/docs/whatsapp/guides/opt-in/"
    },
    {
      "name": "Users",
      "description": "<br><br><br><br>**Users** are people recorded in CommBox and they include both the business side and the customers.<br>Managers are APIs that deal with the business personas such as Admins, Agents, Team leaders, etc., and they include **Profiles**, **Presence**, **Assignments**, **Notifications**, and **Teams** sub-categories.<br><br>General USERS"
    },
    {
      "name": "Managers",
      "description": "<br><br>The **MANAGERS** APIs category relates to activities involving the Admins, Team Leaders, Agents, and any other business-related persona. This category includes **Profiles**, **Presence**, **Assignments**, **Notifications**, and **Teams** sub-categories."
    },
    {
      "name": "Profiles",
      "description": "<br><br>**Profiles** relate to system permissions and enabled activities assigned to a group of agents (managers). <br>When looking for a specific user, the USER ID is required. <br>The profile ID is required when selecting a specific profile (See Enum section)."
    },
    {
      "name": "Presence",
      "description": "<br><br>The Presence APIs relate to the agent availability status. Active and ready for assignment, Busy, or Away from the desk. Additional statuses can be created by the admin."
    },
    {
      "name": "Assignments",
      "description": "<br><br>The **Assignments** category relates to conversations (Objects) assigned to a specific agent."
    },
    {
      "name": "Teams",
      "description": "A Team is a group of agents with specific business agendas, roles, and permissions. Admins and Team Managers can set up Team Managers to create and manage teams and give those teams specific inbox filters, tags, and knowledge-based assets."
    },
    {
      "name": "Audiences",
      "description": "The Audiences APIs allow the creation, editing and listing of organizational audiences used for campaigns."
    },
    {
      "name": "Forms",
      "description": "The Forms APIs allow agents to assist customers in completing and signing forms issued by the organization. Once the customer submits the form, a new object is created that includes a link to the original conversation and stores the completed, signed form as an attachment."
    },
    {
      "name": "Authentication",
      "description": "Authentication APIs provide accessibility to the system."
    },
    {
      "name": "Automation",
      "description": "<br><br>Automation APIs are related to chatbot capabilities."
    },
    {
      "name": "Transcription",
      "description": "<br><br>**Transcription** turns a call recording into readable, speaker-attributed messages inside the conversation."
    }
  ],
  "x-tagGroups": [
    {
      "name": "API Calls",
      "tags": [
        "Core",
        "Objects",
        "Media",
        "AI Services",
        "Streams",
        "Tags",
        "SMS",
        "WhatsApp",
        "Users",
        "Managers",
        "Profiles",
        "Presence",
        "Assignments",
        "Teams",
        "Audiences",
        "Forms",
        "Authentication",
        "Automation"
      ]
    }
  ],
  "paths": {
    "/objects/{objectId}/survey": {
      "post": {
        "tags": [
          "Objects"
        ],
        "summary": "External CSAT",
        "description": "This API enables Organizations to import external customer satisfaction surveys (CSAT) into the CommBox platform, attaching them to existing conversations and tagging the conversation appropriately.<br><br>You'll need to open a designated channel in the Customer Satisfaction Survey Module. The channel ID will be the value for the `surveyStreamId` parameter in the API request. Click [here](https://help.commbox.io/docs/external-csat-api) to learn more.<br><br>**Note:**<br> - The example below is for a single-question survey. Multiple-question arrays are also supported.<br> - The first answer always represents the highest satisfaction score (**100%**), while the last answer represents the lowest satisfaction score (**0%**). Scores for intermediate answers are distributed evenly between these values.",
        "operationId": "Set_Survey_Content",
        "parameters": [
          {
            "name": "OBJECT_ID",
            "in": "path",
            "description": "A CommBox generated number for the conversation",
            "required": true
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "data": {
                    "type": "object",
                    "properties": {
                      "surveyStreamId": {
                        "type": "Number",
                        "format": "int64",
                        "description": "The ID of the Customer Satisfaction Survey channel",
                        "example": 317112
                      },
                      "questionId": {
                        "type": "string",
                        "maxLength": 30,
                        "description": "Unique identifier of the survey question",
                        "example": "q4_quality"
                      },
                      "questionText": {
                        "type": "string",
                        "maxLength": 2000,
                        "description": "The survey question was presented to the customer",
                        "example": "How would you rate the quality of our service?"
                      },
                      "answerOptions": {
                        "type": "array",
                        "description": "Available answer choices for the user to select from",
                        "items": {
                          "type": "string"
                        },
                        "maxItems": 40,
                        "example": [
                          [
                            "Great!",
                            "OK",
                            "Could be better"
                          ]
                        ]
                      },
                      "selectedAnswer": {
                        "type": "string",
                        "maxLength": 500,
                        "description": "The answer selected by the customer",
                        "example": 1
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "integer",
                      "example": 200
                    },
                    "description": {
                      "type": "string",
                      "example": "Operation successful"
                    },
                    "response_time": {
                      "type": "string",
                      "example": "2024-08-06T07:51:52.2581942Z"
                    },
                    "data": {
                      "type": "string",
                      "example": null
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad Request - The request could not be understood by the server. Incoming parameters might not be valid",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "integer",
                      "example": 400
                    },
                    "description": {
                      "type": "string",
                      "example": "Bad Request"
                    },
                    "response_time": {
                      "type": "string",
                      "format": "date-time",
                      "example": "2025-02-06T07:51:52.2581942Z"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized - The supplied credentials, if any, are not sufficient to access the resource",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "integer",
                      "example": 401
                    },
                    "description": {
                      "type": "string",
                      "example": "Unauthorized"
                    },
                    "response_time": {
                      "type": "string",
                      "format": "date-time",
                      "example": "2025-02-06T07:51:52.2581942Z"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found - The requested resource is not found",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "integer",
                      "example": 404
                    },
                    "description": {
                      "type": "string",
                      "example": "Not Found"
                    },
                    "response_time": {
                      "type": "string",
                      "format": "date-time",
                      "example": "2025-02-06T07:51:52.2581942Z"
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too Many Requests - Too many requests have been made in a short period of time (Throttling)",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "integer",
                      "example": 429
                    },
                    "description": {
                      "type": "string",
                      "example": "Too Many Requests"
                    },
                    "response_time": {
                      "type": "string",
                      "format": "date-time",
                      "example": "2025-02-06T07:51:52.2581942Z"
                    }
                  }
                }
              }
            }
          },
          "500": {
            "description": "Server Error - The server could not return the representation due to an internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "integer",
                      "example": 500
                    },
                    "description": {
                      "type": "string",
                      "example": "Internal Server Error"
                    },
                    "response_time": {
                      "type": "string",
                      "format": "date-time",
                      "example": "2025-02-06T07:51:52.2581942Z"
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "securitySchemes": {
      "BearerAuth": {
        "type": "http",
        "scheme": "bearer",
        "description": "API key is needed to authorize requests. You can get your API key via the management console. </br><b> A Bearer Token is needed to be set in the Authorization header of every API call.</b></br> For additional support you can contact us."
      }
    }
  }
}
````

